// generated by verigenSV.pl on Tue Jun  8 12:01:38 2021
// input file: cache.cfg

// compiler directives
/* verilator lint_off CASEINCOMPLETE */
/* verilator lint_off DECLFILENAME */
/* verilator lint_off UNUSED */
/* verilator lint_off STMTDLY */
/* verilator lint_off UNOPTFLAT */


module CACHE (
	input logic clk,
	input logic res_n,
	input logic lock,
	input logic unlock,
	input logic [KEY_WIDTH-1:0] key,
	input logic [PHYS_ADDR_WIDTH-1:0] phys_addr_in,
	input logic phys_addr_in_vld,
	input logic [BLOCK_SIZE-1:0] data_from_mem,
	input logic data_from_mem_vld,
	input logic [BLOCK_SIZE-1:0] data_from_cpu,
	input logic data_from_cpu_vld,
	output logic [BLOCK_SIZE-1:0] data_to_cpu, 
	output logic data_to_cpu_vld, 
	output logic [BLOCK_SIZE-1:0] data_to_victim_buffer, 
	output logic data_to_victim_buffer_vld, 
	output logic miss, 
	output logic locked );

  //
 // parameter constants 
//---------------------------
parameter int CACHE_SIZE = 256;
parameter int PHYS_ADDR_WIDTH = 40;
parameter int INDEX_WIDTH = 9;
parameter int OFFSET_WIDTH = 6;
parameter int KEY_WIDTH = 32; ;
parameter logic [KEY_WIDTH-1:0] KEY = {KEY_WIDTH{1'b1}};


  //
 // state encoding typedef 
//--------------------------------
typedef enum logic [3:0] {
	LOCKED = 4'b1111,
	IDLE = 4'b0000,
	RD_REQ = 4'b1000,
	RD_REQ_MISS = 4'b1011,
	RD_REQ_HIT_B0 = 4'b1001,
	RD_REQ_HIT_B1 = 4'b1010,
	WR_REQ = 4'b0100,
	WR_REQ_MISS = 4'b0111,
	WR_REQ_HIT_B0 = 4'b0101,
	WR_REQ_HIT_B1 = 4'b0110
} states_t;


// internal state variables
states_t STATE, NEXT_STATE;

  //
 // memory instantiations 
//---------------------------
RAM #( BLOCK_SIZE, BLOCK_NUM ) B0_DAT_RAM(
	.clk(clk), .res_n(res_n), 
	.wr(B0_DAT_RAM_wr), .wr_addr(B0_DAT_RAM_wr_addr[INDEX_WIDTH-1:0]), .wr_data(B0_DAT_RAM_wr_data[BLOCK_SIZE-1:0]), 
	.rd(B0_DAT_RAM_rd), .rd_addr(B0_DAT_RAM_rd_addr[INDEX_WIDTH-1:0]), .rd_data(B0_DAT_RAM_rd_data[BLOCK_SIZE-1:0]) );

RAM #( TAG_WIDTH+1, BLOCK_NUM ) B0_TAG_RAM(
	.clk(clk), .res_n(res_n), 
	.wr(B0_TAG_RAM_wr), .wr_addr(B0_TAG_RAM_wr_addr[INDEX_WIDTH-1:0]), .wr_data(B0_TAG_RAM_wr_data[TAG_WIDTH+1-1:0]), 
	.rd(B0_TAG_RAM_rd), .rd_addr(B0_DAT_RAM_rd_addr[INDEX_WIDTH-1:0]), .rd_data(B0_TAG_RAM_rd_data[TAG_WIDTH+1-1:0]) );

RAM #( BLOCK_SIZE, BLOCK_NUM ) B1_DAT_RAM(
	.clk(clk), .res_n(res_n), 
	.wr(B1_DAT_RAM_wr), .wr_addr(B1_DAT_RAM_wr_addr[INDEX_WIDTH-1:0]), .wr_data(B1_DAT_RAM_wr_data[BLOCK_SIZE-1:0]), 
	.rd(B1_DAT_RAM_rd), .rd_addr(B1_DAT_RAM_rd_addr[INDEX_WIDTH-1:0]), .rd_data(B1_DAT_RAM_rd_data[BLOCK_SIZE-1:0]) );

RAM #( TAG_WIDTH+1, BLOCK_NUM ) B1_TAG_RAM(
	.clk(clk), .res_n(res_n), 
	.wr(B1_TAG_RAM_wr), .wr_addr(B1_TAG_RAM_wr_addr[INDEX_WIDTH-1:0]), .wr_data(B1_TAG_RAM_wr_data[TAG_WIDTH+1-1:0]), 
	.rd(B1_TAG_RAM_rd), .rd_addr(B1_TAG_RAM_rd_addr[INDEX_WIDTH-1:0]), .rd_data(B1_TAG_RAM_rd_data[TAG_WIDTH+1-1:0]) );

   //
  // user-defined SystemVerilog support code 
 // (derived from <support> section) 
//----------------------------------
localparam logic ZERO = 1'b0;
localparam logic ONE = 1'b1;
localparam int TAG_WIDTH = PHYS_ADDR_WIDTH-INDEX_WIDTH-OFFSET_WIDTH;
localparam int BLOCK_SIZE = int'($pow(2,OFFSET_WIDTH));
localparam int BLOCK_NUM = int'($pow(2,INDEX_WIDTH));
localparam logic [BLOCK_SIZE-1:0] ZERO_BLOCK = '0;
localparam logic [TAG_WIDTH-1:0] ZERO_TAG = '0;
logic  b0_tag_vld;
logic [TAG_WIDTH-1:0] b0_tag;
logic  b1_tag_vld;
logic [TAG_WIDTH-1:0] b1_tag;
logic [BLOCK_SIZE-1:0] b0_dat;
logic [BLOCK_SIZE-1:0] b1_dat;

   //
  // implicit continuous assignments 
 // (derived from <expressions> section) 
//----------------------------------
assign data_to_victim_buffer = data_to_cpu;
assign data_to_victim_buffer_vld = data_to_cpu_vld;
assign locked = ( STATE == LOCKED );
uwire DO_ABORT; assign DO_ABORT = !(IS_RD_REQ | IS_WR_REQ);
uwire DO_IDLE_RD; assign DO_IDLE_RD = !res_n | !phys_addr_in_vld;
uwire DO_IDLE_WR; assign DO_IDLE_WR = DO_IDLE_RD | !data_from_cpu_vld;
uwire DO_LOCK; assign DO_LOCK = !res_n | lock;
uwire DO_MEM_REQ; assign DO_MEM_REQ = phys_addr_in_vld & !data_from_mem_vld;
uwire DO_UNLOCK; assign DO_UNLOCK = res_n & unlock & IS_KEY_MATCH;
uwire IS_HIT_B0; assign IS_HIT_B0 = b0_tag_vld && (tag==b0_tag);
uwire IS_HIT_B1; assign IS_HIT_B1 = b1_tag_vld && (tag==b1_tag);
uwire IS_KEY_MATCH; assign IS_KEY_MATCH = (KEY==key);
uwire IS_MEM_REQ_DONE; assign IS_MEM_REQ_DONE = phys_addr_in_vld & data_from_mem_vld;
uwire IS_RD_REQ; assign IS_RD_REQ = IS_REQ & !data_from_cpu_vld;
uwire IS_REQ; assign IS_REQ = phys_addr_in_vld;
uwire IS_WR_REQ; assign IS_WR_REQ = IS_REQ &  data_from_cpu_vld;
uwire [INDEX_WIDTH-1:0] index; assign index = phys_addr_in[INDEX_WIDTH-1+OFFSET_WIDTH:OFFSET_WIDTH];
uwire [OFFSET_WIDTH-1:0] offset; assign offset = phys_addr_in[OFFSET_WIDTH-1:0];
uwire [TAG_WIDTH-1:0] tag; assign tag = phys_addr_in[PHYS_ADDR_WIDTH-1:OFFSET_WIDTH+INDEX_WIDTH];

  //
 // initials for simulator
//---------------------------
initial begin
  STATE = LOCKED;
  b0_tag = '0;
  b0_tag_vld = 1'b0;
  b1_tag = '0;
  b1_tag_vld = 1'b0;
  b0_dat = '0;
  b1_dat = '0;

  // dump output (Verilator)
  if ($test$plusargs("trace") != 0) begin
    $display("[%0t] Tracing to logs/vlt_dump.vcd...\n", $time);
    $dumpfile("logs/vlt_dump.vcd");
    $dumpvars();
  end
  $display("[%0t] Model running...\n", $time);

end

  //
 // state transfer
//---------------------------
always_ff @( posedge clk ) begin
  if( res_n )
    STATE <= NEXT_STATE;
  else
    STATE <= LOCKED;

  // condition for $finish (Verilator)
  if( lock==1'b1 && unlock==1'b1 ) begin
    $write("*-* All Finished *-*\n");
    $finish;
  end   

end

// AssertionExample:
//always_ff @ (posedge clk) begin
//   AssertionExample: assert (rd==1'b1 ^ wr==1'b1);
//end

// coverage analysis (Verilator)
cover property (@(posedge clk) phys_addr_in_vld==1'b1);

always_comb begin

    //
   // pre-case (default) assignments 
  //----------------------------------
  b0_tag = ZERO_TAG;
  b0_tag_vld = 1'b0;
  b1_tag = ZERO_TAG;
  b1_tag_vld = 1'b0;
  data_to_cpu = ZERO_BLOCK;
  data_to_cpu_vld = 1'b0;
  miss = 1'b0;
  NOP_B0_DAT_RAM();
  NOP_B0_TAG_RAM();
  NOP_B1_DAT_RAM();
  NOP_B1_TAG_RAM();

  unique case ( STATE )
  LOCKED : begin
	if ( !DO_UNLOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( DO_UNLOCK ) begin
	  NEXT_STATE = IDLE;
	end
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end  end // LOCKED
  IDLE : begin
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( IS_RD_REQ ) begin
	  NEXT_STATE = RD_REQ;
	  {b0_tag_vld,b0_tag} = POP_B0_TAG_RAM(phys_addr_in_vld,index);
	  {b1_tag_vld,b1_tag} = POP_B1_TAG_RAM(phys_addr_in_vld,index);
	end
	if ( IS_WR_REQ ) begin
	  NEXT_STATE = WR_REQ;
	  {b0_tag_vld,b0_tag} = POP_B0_TAG_RAM(phys_addr_in_vld,index);
	  {b1_tag_vld,b1_tag} = POP_B1_TAG_RAM(phys_addr_in_vld,index);
	end
	if ( !IS_REQ ) begin
	  NEXT_STATE = IDLE;
	end  end // IDLE
  RD_REQ : begin
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( IS_HIT_B0 ) begin
	  NEXT_STATE = RD_REQ_HIT_B0;
	  {b0_tag_vld,b0_tag} = POP_B0_TAG_RAM(phys_addr_in_vld,index);
	  b0_dat = POP_B0_DAT_RAM(phys_addr_in_vld,index);
	end
	if ( IS_HIT_B1 & !IS_HIT_B0 ) begin
	  NEXT_STATE = RD_REQ_HIT_B1;
	  {b1_tag_vld,b1_tag} = POP_B1_TAG_RAM(phys_addr_in_vld,index);
	  b1_dat = POP_B1_DAT_RAM(phys_addr_in_vld,index);
	end
	if ( !(IS_HIT_B0 | IS_HIT_B1) ) begin
	  NEXT_STATE = RD_REQ_MISS;
	  miss=1'b1;
	end
	if ( DO_IDLE_RD ) begin
	  NEXT_STATE = IDLE;
	end  end // RD_REQ
  RD_REQ_MISS : begin
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( DO_IDLE_RD ) begin
	  NEXT_STATE = IDLE;
	end
	if ( DO_MEM_REQ ) begin
	  NEXT_STATE = RD_REQ_MISS;
	  miss=1'b1;
	end
	if ( IS_MEM_REQ_DONE && !phys_addr_in[0] ) begin
	  NEXT_STATE = RD_REQ_HIT_B0;
	  PUSH_B0_DAT_RAM(phys_addr_in_vld & data_from_mem_vld,index,data_from_mem);
	  PUSH_B0_TAG_RAM(phys_addr_in_vld,index,{1'b1,tag});
	end
	if ( IS_MEM_REQ_DONE &&  phys_addr_in[0] ) begin
	  NEXT_STATE = RD_REQ_HIT_B1;
	  PUSH_B1_DAT_RAM(phys_addr_in_vld & data_from_mem_vld,index,data_from_mem);
	  PUSH_B1_TAG_RAM(phys_addr_in_vld,index,{1'b1,tag});
	end  end // RD_REQ_MISS
  RD_REQ_HIT_B0 : begin
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( phys_addr_in_vld ) begin
	  NEXT_STATE = RD_REQ_HIT_B0;
	  b0_dat = POP_B0_DAT_RAM(phys_addr_in_vld,index);
	  data_to_cpu=b0_dat;
	  data_to_cpu_vld=1'b1;
	end
	if ( DO_IDLE_RD ) begin
	  NEXT_STATE = IDLE;
	end  end // RD_REQ_HIT_B0
  RD_REQ_HIT_B1 : begin
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( phys_addr_in_vld ) begin
	  NEXT_STATE = RD_REQ_HIT_B1;
	  b1_dat = POP_B1_DAT_RAM(phys_addr_in_vld,index);
	  data_to_cpu=b1_dat;
	  data_to_cpu_vld=1'b1;
	end
	if ( DO_IDLE_RD ) begin
	  NEXT_STATE = IDLE;
	end  end // RD_REQ_HIT_B1
  WR_REQ : begin
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( IS_HIT_B0 ) begin
	  NEXT_STATE = WR_REQ_HIT_B0;
	  {b0_tag_vld,b0_tag} = POP_B0_TAG_RAM(phys_addr_in_vld,index);
	  PUSH_B0_DAT_RAM(phys_addr_in_vld & data_from_cpu_vld,index,data_from_cpu);
	end
	if ( IS_HIT_B1 & !IS_HIT_B0 ) begin
	  NEXT_STATE = WR_REQ_HIT_B1;
	  {b1_tag_vld,b1_tag} = POP_B1_TAG_RAM(phys_addr_in_vld,index);
	  PUSH_B1_DAT_RAM(phys_addr_in_vld & data_from_cpu_vld,index,data_from_cpu);
	end
	if ( !(IS_HIT_B0 | IS_HIT_B1) && !phys_addr_in[0] ) begin
	  NEXT_STATE = WR_REQ_MISS;
	  miss=1'b1;
	end
	if ( !(IS_HIT_B0 | IS_HIT_B1) &&  phys_addr_in[0] ) begin
	  NEXT_STATE = WR_REQ_MISS;
	  miss=1'b1;
	end
	if ( DO_IDLE_WR ) begin
	  NEXT_STATE = IDLE;
	end  end // WR_REQ
  WR_REQ_MISS : begin
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( DO_MEM_REQ ) begin
	  NEXT_STATE = WR_REQ_MISS;
	  miss=1'b1;
	end
	if ( IS_MEM_REQ_DONE && !phys_addr_in[0] ) begin
	  NEXT_STATE = WR_REQ_HIT_B0;
	  PUSH_B0_DAT_RAM(phys_addr_in_vld & data_from_cpu_vld,index,data_from_cpu);
	  PUSH_B0_TAG_RAM(phys_addr_in_vld,index,{1'b1,tag});
	end
	if ( IS_MEM_REQ_DONE &&  phys_addr_in[0] ) begin
	  NEXT_STATE = WR_REQ_HIT_B1;
	  PUSH_B1_DAT_RAM(phys_addr_in_vld & data_from_cpu_vld,index,data_from_cpu);
	  PUSH_B1_TAG_RAM(phys_addr_in_vld,index,{1'b1,tag});
	end
	if ( DO_IDLE_WR ) begin
	  NEXT_STATE = IDLE;
	end  end // WR_REQ_MISS
  WR_REQ_HIT_B0 : begin
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( phys_addr_in_vld && data_from_cpu_vld ) begin
	  NEXT_STATE = WR_REQ_HIT_B0;
	  b0_dat = POP_B0_DAT_RAM(phys_addr_in_vld,index);
	  data_to_cpu=b0_dat;
	  data_to_cpu_vld=1'b1;
	end
	if ( DO_IDLE_WR ) begin
	  NEXT_STATE = IDLE;
	end  end // WR_REQ_HIT_B0
  WR_REQ_HIT_B1 : begin
	if ( DO_LOCK ) begin
	  NEXT_STATE = LOCKED;
	end
	if ( phys_addr_in_vld && data_from_cpu_vld ) begin
	  NEXT_STATE = WR_REQ_HIT_B1;
	  b1_dat = POP_B1_DAT_RAM(phys_addr_in_vld,index);
	  data_to_cpu=b1_dat;
	  data_to_cpu_vld=1'b1;
	end
	if ( DO_IDLE_WR ) begin
	  NEXT_STATE = IDLE;
	end  end // WR_REQ_HIT_B1
  endcase
end // always_comb


  //
 // memory functions
//---------------------------
logic B0_DAT_RAM_rd;
logic [BLOCK_SIZE-1:0] B0_DAT_RAM_rd_data;
logic [$clog2(BLOCK_NUM)-1:0] B0_DAT_RAM_rd_addr;

function automatic [BLOCK_SIZE-1:0] POP_B0_DAT_RAM( read, [$clog2(BLOCK_NUM)-1:0] read_addr);
   B0_DAT_RAM_rd = read;
   B0_DAT_RAM_rd_addr = read_addr;
   return B0_DAT_RAM_rd_data;
endfunction

logic B0_DAT_RAM_wr;
logic [BLOCK_SIZE-1:0] B0_DAT_RAM_wr_data;
logic [$clog2(BLOCK_NUM)-1:0] B0_DAT_RAM_wr_addr;

function automatic void PUSH_B0_DAT_RAM( write, [$clog2(BLOCK_NUM)-1:0] write_addr, [BLOCK_SIZE-1:0] write_data);
   B0_DAT_RAM_wr = write;
   B0_DAT_RAM_wr_addr = write_addr;
   B0_DAT_RAM_wr_data = write_data;
endfunction

function automatic void NOP_B0_DAT_RAM();
   B0_DAT_RAM_rd = 0;
   B0_DAT_RAM_wr = 0;
   B0_DAT_RAM_wr_addr = '0;
   B0_DAT_RAM_wr_data = '0;
   B0_DAT_RAM_rd_addr = '0;
endfunction

logic B0_TAG_RAM_rd;
logic [TAG_WIDTH+1-1:0] B0_TAG_RAM_rd_data;
logic [$clog2(BLOCK_NUM)-1:0] B0_TAG_RAM_rd_addr;

function automatic [TAG_WIDTH+1-1:0] POP_B0_TAG_RAM( read, [$clog2(BLOCK_NUM)-1:0] read_addr);
   B0_TAG_RAM_rd = read;
   B0_TAG_RAM_rd_addr = read_addr;
   return B0_TAG_RAM_rd_data;
endfunction

logic B0_TAG_RAM_wr;
logic [TAG_WIDTH+1-1:0] B0_TAG_RAM_wr_data;
logic [$clog2(BLOCK_NUM)-1:0] B0_TAG_RAM_wr_addr;

function automatic void PUSH_B0_TAG_RAM( write, [$clog2(BLOCK_NUM)-1:0] write_addr, [TAG_WIDTH+1-1:0] write_data);
   B0_TAG_RAM_wr = write;
   B0_TAG_RAM_wr_addr = write_addr;
   B0_TAG_RAM_wr_data = write_data;
endfunction

function automatic void NOP_B0_TAG_RAM();
   B0_TAG_RAM_rd = 0;
   B0_TAG_RAM_wr = 0;
   B0_TAG_RAM_wr_addr = '0;
   B0_TAG_RAM_wr_data = '0;
   B0_TAG_RAM_rd_addr = '0;
endfunction

logic B1_DAT_RAM_rd;
logic [BLOCK_SIZE-1:0] B1_DAT_RAM_rd_data;
logic [$clog2(BLOCK_NUM)-1:0] B1_DAT_RAM_rd_addr;

function automatic [BLOCK_SIZE-1:0] POP_B1_DAT_RAM( read, [$clog2(BLOCK_NUM)-1:0] read_addr);
   B1_DAT_RAM_rd = read;
   B1_DAT_RAM_rd_addr = read_addr;
   return B1_DAT_RAM_rd_data;
endfunction

logic B1_DAT_RAM_wr;
logic [BLOCK_SIZE-1:0] B1_DAT_RAM_wr_data;
logic [$clog2(BLOCK_NUM)-1:0] B1_DAT_RAM_wr_addr;

function automatic void PUSH_B1_DAT_RAM( write, [$clog2(BLOCK_NUM)-1:0] write_addr, [BLOCK_SIZE-1:0] write_data);
   B1_DAT_RAM_wr = write;
   B1_DAT_RAM_wr_addr = write_addr;
   B1_DAT_RAM_wr_data = write_data;
endfunction

function automatic void NOP_B1_DAT_RAM();
   B1_DAT_RAM_rd = 0;
   B1_DAT_RAM_wr = 0;
   B1_DAT_RAM_wr_addr = '0;
   B1_DAT_RAM_wr_data = '0;
   B1_DAT_RAM_rd_addr = '0;
endfunction

logic B1_TAG_RAM_rd;
logic [TAG_WIDTH+1-1:0] B1_TAG_RAM_rd_data;
logic [$clog2(BLOCK_NUM)-1:0] B1_TAG_RAM_rd_addr;

function automatic [TAG_WIDTH+1-1:0] POP_B1_TAG_RAM( read, [$clog2(BLOCK_NUM)-1:0] read_addr);
   B1_TAG_RAM_rd = read;
   B1_TAG_RAM_rd_addr = read_addr;
   return B1_TAG_RAM_rd_data;
endfunction

logic B1_TAG_RAM_wr;
logic [TAG_WIDTH+1-1:0] B1_TAG_RAM_wr_data;
logic [$clog2(BLOCK_NUM)-1:0] B1_TAG_RAM_wr_addr;

function automatic void PUSH_B1_TAG_RAM( write, [$clog2(BLOCK_NUM)-1:0] write_addr, [TAG_WIDTH+1-1:0] write_data);
   B1_TAG_RAM_wr = write;
   B1_TAG_RAM_wr_addr = write_addr;
   B1_TAG_RAM_wr_data = write_data;
endfunction

function automatic void NOP_B1_TAG_RAM();
   B1_TAG_RAM_rd = 0;
   B1_TAG_RAM_wr = 0;
   B1_TAG_RAM_wr_addr = '0;
   B1_TAG_RAM_wr_data = '0;
   B1_TAG_RAM_rd_addr = '0;
endfunction

endmodule


  //
 // memory
//---------------------------
module RAM ( clk, res_n, wr, wr_addr, wr_data, rd, rd_addr, rd_data );

parameter DATA_WIDTH = 32;
parameter NUM_ENTRIES = 16;
parameter ADDR_WIDTH = $clog2(NUM_ENTRIES);

input  uwire clk, res_n, rd, wr;
input  uwire [DATA_WIDTH-1:0] wr_data;
input  uwire [ADDR_WIDTH-1:0] rd_addr, wr_addr;
output uwire [DATA_WIDTH-1:0] rd_data;

parameter ZERO_ADDR = {ADDR_WIDTH{1'b0}};
parameter ZERO_DATA = {DATA_WIDTH{1'b0}};
parameter ONE_DATA = {DATA_WIDTH{1'b1}};
    
logic    [DATA_WIDTH-1:0] MEMORY [NUM_ENTRIES-1:0];

integer i;

initial begin
   // Clear RAM before simulation start
   for ( i = 0; i < NUM_ENTRIES; i = i + 1 ) begin
       MEMORY[ i ] = ZERO_DATA;
   end
end

// IN-CYCLE READ ACCESS
assign rd_data =  ( rd & res_n ) ? MEMORY[rd_addr] : 'Z;

always_ff @ ( posedge clk ) begin
    // WRITE ACCESS
   if( res_n ) begin
     if( wr ) MEMORY[wr_addr] <= wr_data;
   end else begin
     MEMORY <= '{default:'0};
   end
end

endmodule
