// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "VCACHE__Syms.h"


//======================

void VCACHE::_traceDump() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumperp->dump(VL_TIME_Q());
}
void VCACHE::_traceDumpOpen() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    if (VL_UNLIKELY(!__VlSymsp->__Vm_dumperp)) {
        __VlSymsp->__Vm_dumperp = new VerilatedVcdC();
        const char* cp = vl_dumpctl_filenamep();
        trace(__VlSymsp->__Vm_dumperp, 0, 0);
        __VlSymsp->__Vm_dumperp->open(vl_dumpctl_filenamep());
        __VlSymsp->__Vm_dumperp->changeThread();
        __VlSymsp->__Vm_dumping = true;
    }
}
void VCACHE::_traceDumpClose() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumping = false;
    VL_DO_CLEAR(delete __VlSymsp->__Vm_dumperp, __VlSymsp->__Vm_dumperp = nullptr);
}
void VCACHE::trace(VerilatedVcdC* tfp, int, int) {
    tfp->spTrace()->addInitCb(&traceInit, __VlSymsp);
    traceRegister(tfp->spTrace());
}

void VCACHE::traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) {
    // Callback from tracep->open()
    VCACHE__Syms* __restrict vlSymsp = static_cast<VCACHE__Syms*>(userp);
    if (!Verilated::calcUnusedSigs()) {
        VL_FATAL_MT(__FILE__, __LINE__, __FILE__,
                        "Turning on wave traces requires Verilated::traceEverOn(true) call before time 0.");
    }
    vlSymsp->__Vm_baseCode = code;
    tracep->module(vlSymsp->name());
    tracep->scopeEscape(' ');
    VCACHE::traceInitTop(vlSymsp, tracep);
    tracep->scopeEscape('.');
}

//======================


void VCACHE::traceInitTop(void* userp, VerilatedVcd* tracep) {
    VCACHE__Syms* __restrict vlSymsp = static_cast<VCACHE__Syms*>(userp);
    VCACHE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceInitSub0(userp, tracep);
    }
}

void VCACHE::traceInitSub0(void* userp, VerilatedVcd* tracep) {
    VCACHE__Syms* __restrict vlSymsp = static_cast<VCACHE__Syms*>(userp);
    VCACHE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    const int c = vlSymsp->__Vm_baseCode;
    if (false && tracep && c) {}  // Prevent unused
    // Body
    {
        tracep->declBit(c+53,"clk", false,-1);
        tracep->declBit(c+54,"res_n", false,-1);
        tracep->declBit(c+55,"lock", false,-1);
        tracep->declBit(c+56,"unlock", false,-1);
        tracep->declBus(c+57,"key", false,-1, 31,0);
        tracep->declQuad(c+58,"phys_addr_in", false,-1, 39,0);
        tracep->declBit(c+60,"phys_addr_in_vld", false,-1);
        tracep->declQuad(c+61,"data_from_mem", false,-1, 63,0);
        tracep->declBit(c+63,"data_from_mem_vld", false,-1);
        tracep->declQuad(c+64,"data_from_cpu", false,-1, 63,0);
        tracep->declBit(c+66,"data_from_cpu_vld", false,-1);
        tracep->declQuad(c+67,"data_to_cpu", false,-1, 63,0);
        tracep->declBit(c+69,"data_to_cpu_vld", false,-1);
        tracep->declQuad(c+70,"data_to_victim_buffer", false,-1, 63,0);
        tracep->declBit(c+72,"data_to_victim_buffer_vld", false,-1);
        tracep->declBit(c+73,"miss", false,-1);
        tracep->declBit(c+74,"locked", false,-1);
        tracep->declBit(c+53,"CACHE clk", false,-1);
        tracep->declBit(c+54,"CACHE res_n", false,-1);
        tracep->declBit(c+55,"CACHE lock", false,-1);
        tracep->declBit(c+56,"CACHE unlock", false,-1);
        tracep->declBus(c+57,"CACHE key", false,-1, 31,0);
        tracep->declQuad(c+58,"CACHE phys_addr_in", false,-1, 39,0);
        tracep->declBit(c+60,"CACHE phys_addr_in_vld", false,-1);
        tracep->declQuad(c+61,"CACHE data_from_mem", false,-1, 63,0);
        tracep->declBit(c+63,"CACHE data_from_mem_vld", false,-1);
        tracep->declQuad(c+64,"CACHE data_from_cpu", false,-1, 63,0);
        tracep->declBit(c+66,"CACHE data_from_cpu_vld", false,-1);
        tracep->declQuad(c+67,"CACHE data_to_cpu", false,-1, 63,0);
        tracep->declBit(c+69,"CACHE data_to_cpu_vld", false,-1);
        tracep->declQuad(c+70,"CACHE data_to_victim_buffer", false,-1, 63,0);
        tracep->declBit(c+72,"CACHE data_to_victim_buffer_vld", false,-1);
        tracep->declBit(c+73,"CACHE miss", false,-1);
        tracep->declBit(c+74,"CACHE locked", false,-1);
        tracep->declBus(c+80,"CACHE CACHE_SIZE", false,-1, 31,0);
        tracep->declBus(c+81,"CACHE PHYS_ADDR_WIDTH", false,-1, 31,0);
        tracep->declBus(c+82,"CACHE INDEX_WIDTH", false,-1, 31,0);
        tracep->declBus(c+83,"CACHE OFFSET_WIDTH", false,-1, 31,0);
        tracep->declBus(c+84,"CACHE KEY_WIDTH", false,-1, 31,0);
        tracep->declBus(c+85,"CACHE KEY", false,-1, 31,0);
        tracep->declBus(c+75,"CACHE STATE", false,-1, 3,0);
        tracep->declBus(c+5,"CACHE NEXT_STATE", false,-1, 3,0);
        tracep->declBit(c+86,"CACHE ZERO", false,-1);
        tracep->declBit(c+87,"CACHE ONE", false,-1);
        tracep->declBus(c+88,"CACHE TAG_WIDTH", false,-1, 31,0);
        tracep->declBus(c+89,"CACHE BLOCK_SIZE", false,-1, 31,0);
        tracep->declBus(c+90,"CACHE BLOCK_NUM", false,-1, 31,0);
        tracep->declQuad(c+91,"CACHE ZERO_BLOCK", false,-1, 63,0);
        tracep->declBus(c+93,"CACHE ZERO_TAG", false,-1, 24,0);
        tracep->declBit(c+6,"CACHE b0_tag_vld", false,-1);
        tracep->declBus(c+7,"CACHE b0_tag", false,-1, 24,0);
        tracep->declBit(c+8,"CACHE b1_tag_vld", false,-1);
        tracep->declBus(c+9,"CACHE b1_tag", false,-1, 24,0);
        tracep->declQuad(c+10,"CACHE b0_dat", false,-1, 63,0);
        tracep->declQuad(c+12,"CACHE b1_dat", false,-1, 63,0);
        tracep->declBit(c+14,"CACHE DO_ABORT", false,-1);
        tracep->declBit(c+15,"CACHE DO_IDLE_RD", false,-1);
        tracep->declBit(c+16,"CACHE DO_IDLE_WR", false,-1);
        tracep->declBit(c+17,"CACHE DO_LOCK", false,-1);
        tracep->declBit(c+18,"CACHE DO_MEM_REQ", false,-1);
        tracep->declBit(c+19,"CACHE DO_UNLOCK", false,-1);
        tracep->declBit(c+20,"CACHE IS_HIT_B0", false,-1);
        tracep->declBit(c+21,"CACHE IS_HIT_B1", false,-1);
        tracep->declBit(c+76,"CACHE IS_KEY_MATCH", false,-1);
        tracep->declBit(c+22,"CACHE IS_MEM_REQ_DONE", false,-1);
        tracep->declBit(c+23,"CACHE IS_RD_REQ", false,-1);
        tracep->declBit(c+60,"CACHE IS_REQ", false,-1);
        tracep->declBit(c+24,"CACHE IS_WR_REQ", false,-1);
        tracep->declBus(c+77,"CACHE index", false,-1, 8,0);
        tracep->declBus(c+78,"CACHE offset", false,-1, 5,0);
        tracep->declBus(c+79,"CACHE tag", false,-1, 24,0);
        tracep->declBit(c+25,"CACHE B0_DAT_RAM_rd", false,-1);
        tracep->declQuad(c+26,"CACHE B0_DAT_RAM_rd_data", false,-1, 63,0);
        tracep->declBus(c+28,"CACHE B0_DAT_RAM_rd_addr", false,-1, 8,0);
        tracep->declBit(c+29,"CACHE B0_DAT_RAM_wr", false,-1);
        tracep->declQuad(c+30,"CACHE B0_DAT_RAM_wr_data", false,-1, 63,0);
        tracep->declBus(c+32,"CACHE B0_DAT_RAM_wr_addr", false,-1, 8,0);
        tracep->declBit(c+33,"CACHE B0_TAG_RAM_rd", false,-1);
        tracep->declBus(c+34,"CACHE B0_TAG_RAM_rd_data", false,-1, 25,0);
        tracep->declBus(c+35,"CACHE B0_TAG_RAM_rd_addr", false,-1, 8,0);
        tracep->declBit(c+36,"CACHE B0_TAG_RAM_wr", false,-1);
        tracep->declBus(c+37,"CACHE B0_TAG_RAM_wr_data", false,-1, 25,0);
        tracep->declBus(c+38,"CACHE B0_TAG_RAM_wr_addr", false,-1, 8,0);
        tracep->declBit(c+39,"CACHE B1_DAT_RAM_rd", false,-1);
        tracep->declQuad(c+40,"CACHE B1_DAT_RAM_rd_data", false,-1, 63,0);
        tracep->declBus(c+42,"CACHE B1_DAT_RAM_rd_addr", false,-1, 8,0);
        tracep->declBit(c+43,"CACHE B1_DAT_RAM_wr", false,-1);
        tracep->declQuad(c+44,"CACHE B1_DAT_RAM_wr_data", false,-1, 63,0);
        tracep->declBus(c+46,"CACHE B1_DAT_RAM_wr_addr", false,-1, 8,0);
        tracep->declBit(c+47,"CACHE B1_TAG_RAM_rd", false,-1);
        tracep->declBus(c+48,"CACHE B1_TAG_RAM_rd_data", false,-1, 25,0);
        tracep->declBus(c+49,"CACHE B1_TAG_RAM_rd_addr", false,-1, 8,0);
        tracep->declBit(c+50,"CACHE B1_TAG_RAM_wr", false,-1);
        tracep->declBus(c+51,"CACHE B1_TAG_RAM_wr_data", false,-1, 25,0);
        tracep->declBus(c+52,"CACHE B1_TAG_RAM_wr_addr", false,-1, 8,0);
        tracep->declBus(c+94,"CACHE B0_TAG_RAM DATA_WIDTH", false,-1, 31,0);
        tracep->declBus(c+95,"CACHE B0_TAG_RAM NUM_ENTRIES", false,-1, 31,0);
        tracep->declBus(c+96,"CACHE B0_TAG_RAM ADDR_WIDTH", false,-1, 31,0);
        tracep->declBit(c+53,"CACHE B0_TAG_RAM clk", false,-1);
        tracep->declBit(c+54,"CACHE B0_TAG_RAM res_n", false,-1);
        tracep->declBit(c+33,"CACHE B0_TAG_RAM rd", false,-1);
        tracep->declBit(c+36,"CACHE B0_TAG_RAM wr", false,-1);
        tracep->declBus(c+37,"CACHE B0_TAG_RAM wr_data", false,-1, 25,0);
        tracep->declBus(c+28,"CACHE B0_TAG_RAM rd_addr", false,-1, 8,0);
        tracep->declBus(c+38,"CACHE B0_TAG_RAM wr_addr", false,-1, 8,0);
        tracep->declBus(c+34,"CACHE B0_TAG_RAM rd_data", false,-1, 25,0);
        tracep->declBus(c+97,"CACHE B0_TAG_RAM ZERO_ADDR", false,-1, 8,0);
        tracep->declBus(c+98,"CACHE B0_TAG_RAM ZERO_DATA", false,-1, 25,0);
        tracep->declBus(c+99,"CACHE B0_TAG_RAM ONE_DATA", false,-1, 25,0);
        tracep->declBus(c+1,"CACHE B0_TAG_RAM i", false,-1, 31,0);
        tracep->declBus(c+94,"CACHE B1_TAG_RAM DATA_WIDTH", false,-1, 31,0);
        tracep->declBus(c+95,"CACHE B1_TAG_RAM NUM_ENTRIES", false,-1, 31,0);
        tracep->declBus(c+96,"CACHE B1_TAG_RAM ADDR_WIDTH", false,-1, 31,0);
        tracep->declBit(c+53,"CACHE B1_TAG_RAM clk", false,-1);
        tracep->declBit(c+54,"CACHE B1_TAG_RAM res_n", false,-1);
        tracep->declBit(c+47,"CACHE B1_TAG_RAM rd", false,-1);
        tracep->declBit(c+50,"CACHE B1_TAG_RAM wr", false,-1);
        tracep->declBus(c+51,"CACHE B1_TAG_RAM wr_data", false,-1, 25,0);
        tracep->declBus(c+49,"CACHE B1_TAG_RAM rd_addr", false,-1, 8,0);
        tracep->declBus(c+52,"CACHE B1_TAG_RAM wr_addr", false,-1, 8,0);
        tracep->declBus(c+48,"CACHE B1_TAG_RAM rd_data", false,-1, 25,0);
        tracep->declBus(c+97,"CACHE B1_TAG_RAM ZERO_ADDR", false,-1, 8,0);
        tracep->declBus(c+98,"CACHE B1_TAG_RAM ZERO_DATA", false,-1, 25,0);
        tracep->declBus(c+99,"CACHE B1_TAG_RAM ONE_DATA", false,-1, 25,0);
        tracep->declBus(c+2,"CACHE B1_TAG_RAM i", false,-1, 31,0);
        tracep->declBus(c+100,"CACHE B0_DAT_RAM DATA_WIDTH", false,-1, 31,0);
        tracep->declBus(c+95,"CACHE B0_DAT_RAM NUM_ENTRIES", false,-1, 31,0);
        tracep->declBus(c+96,"CACHE B0_DAT_RAM ADDR_WIDTH", false,-1, 31,0);
        tracep->declBit(c+53,"CACHE B0_DAT_RAM clk", false,-1);
        tracep->declBit(c+54,"CACHE B0_DAT_RAM res_n", false,-1);
        tracep->declBit(c+25,"CACHE B0_DAT_RAM rd", false,-1);
        tracep->declBit(c+29,"CACHE B0_DAT_RAM wr", false,-1);
        tracep->declQuad(c+30,"CACHE B0_DAT_RAM wr_data", false,-1, 63,0);
        tracep->declBus(c+28,"CACHE B0_DAT_RAM rd_addr", false,-1, 8,0);
        tracep->declBus(c+32,"CACHE B0_DAT_RAM wr_addr", false,-1, 8,0);
        tracep->declQuad(c+26,"CACHE B0_DAT_RAM rd_data", false,-1, 63,0);
        tracep->declBus(c+97,"CACHE B0_DAT_RAM ZERO_ADDR", false,-1, 8,0);
        tracep->declQuad(c+91,"CACHE B0_DAT_RAM ZERO_DATA", false,-1, 63,0);
        tracep->declQuad(c+101,"CACHE B0_DAT_RAM ONE_DATA", false,-1, 63,0);
        tracep->declBus(c+3,"CACHE B0_DAT_RAM i", false,-1, 31,0);
        tracep->declBus(c+100,"CACHE B1_DAT_RAM DATA_WIDTH", false,-1, 31,0);
        tracep->declBus(c+95,"CACHE B1_DAT_RAM NUM_ENTRIES", false,-1, 31,0);
        tracep->declBus(c+96,"CACHE B1_DAT_RAM ADDR_WIDTH", false,-1, 31,0);
        tracep->declBit(c+53,"CACHE B1_DAT_RAM clk", false,-1);
        tracep->declBit(c+54,"CACHE B1_DAT_RAM res_n", false,-1);
        tracep->declBit(c+39,"CACHE B1_DAT_RAM rd", false,-1);
        tracep->declBit(c+43,"CACHE B1_DAT_RAM wr", false,-1);
        tracep->declQuad(c+44,"CACHE B1_DAT_RAM wr_data", false,-1, 63,0);
        tracep->declBus(c+42,"CACHE B1_DAT_RAM rd_addr", false,-1, 8,0);
        tracep->declBus(c+46,"CACHE B1_DAT_RAM wr_addr", false,-1, 8,0);
        tracep->declQuad(c+40,"CACHE B1_DAT_RAM rd_data", false,-1, 63,0);
        tracep->declBus(c+97,"CACHE B1_DAT_RAM ZERO_ADDR", false,-1, 8,0);
        tracep->declQuad(c+91,"CACHE B1_DAT_RAM ZERO_DATA", false,-1, 63,0);
        tracep->declQuad(c+101,"CACHE B1_DAT_RAM ONE_DATA", false,-1, 63,0);
        tracep->declBus(c+4,"CACHE B1_DAT_RAM i", false,-1, 31,0);
    }
}

void VCACHE::traceRegister(VerilatedVcd* tracep) {
    // Body
    {
        tracep->addFullCb(&traceFullTop0, __VlSymsp);
        tracep->addChgCb(&traceChgTop0, __VlSymsp);
        tracep->addCleanupCb(&traceCleanup, __VlSymsp);
    }
}

void VCACHE::traceFullTop0(void* userp, VerilatedVcd* tracep) {
    VCACHE__Syms* __restrict vlSymsp = static_cast<VCACHE__Syms*>(userp);
    VCACHE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceFullSub0(userp, tracep);
    }
}

void VCACHE::traceFullSub0(void* userp, VerilatedVcd* tracep) {
    VCACHE__Syms* __restrict vlSymsp = static_cast<VCACHE__Syms*>(userp);
    VCACHE* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    vluint32_t* const oldp = tracep->oldp(vlSymsp->__Vm_baseCode);
    if (false && oldp) {}  // Prevent unused
    // Body
    {
        tracep->fullIData(oldp+1,(vlTOPp->CACHE__DOT__B0_TAG_RAM__DOT__i),32);
        tracep->fullIData(oldp+2,(vlTOPp->CACHE__DOT__B1_TAG_RAM__DOT__i),32);
        tracep->fullIData(oldp+3,(vlSymsp->TOP__CACHE__DOT__B0_DAT_RAM.__PVT__i),32);
        tracep->fullIData(oldp+4,(vlSymsp->TOP__CACHE__DOT__B1_DAT_RAM.__PVT__i),32);
        tracep->fullCData(oldp+5,(vlTOPp->CACHE__DOT__NEXT_STATE),4);
        tracep->fullBit(oldp+6,(vlTOPp->CACHE__DOT__b0_tag_vld));
        tracep->fullIData(oldp+7,(vlTOPp->CACHE__DOT__b0_tag),25);
        tracep->fullBit(oldp+8,(vlTOPp->CACHE__DOT__b1_tag_vld));
        tracep->fullIData(oldp+9,(vlTOPp->CACHE__DOT__b1_tag),25);
        tracep->fullQData(oldp+10,(vlTOPp->CACHE__DOT__b0_dat),64);
        tracep->fullQData(oldp+12,(vlTOPp->CACHE__DOT__b1_dat),64);
        tracep->fullBit(oldp+14,((1U & (~ ((IData)(vlTOPp->CACHE__DOT__IS_RD_REQ) 
                                           | (IData)(vlTOPp->CACHE__DOT__IS_WR_REQ))))));
        tracep->fullBit(oldp+15,(vlTOPp->CACHE__DOT__DO_IDLE_RD));
        tracep->fullBit(oldp+16,(vlTOPp->CACHE__DOT__DO_IDLE_WR));
        tracep->fullBit(oldp+17,(vlTOPp->CACHE__DOT__DO_LOCK));
        tracep->fullBit(oldp+18,(vlTOPp->CACHE__DOT__DO_MEM_REQ));
        tracep->fullBit(oldp+19,(vlTOPp->CACHE__DOT__DO_UNLOCK));
        tracep->fullBit(oldp+20,(vlTOPp->CACHE__DOT__IS_HIT_B0));
        tracep->fullBit(oldp+21,(vlTOPp->CACHE__DOT__IS_HIT_B1));
        tracep->fullBit(oldp+22,(vlTOPp->CACHE__DOT__IS_MEM_REQ_DONE));
        tracep->fullBit(oldp+23,(vlTOPp->CACHE__DOT__IS_RD_REQ));
        tracep->fullBit(oldp+24,(vlTOPp->CACHE__DOT__IS_WR_REQ));
        tracep->fullBit(oldp+25,(vlTOPp->CACHE__DOT__B0_DAT_RAM_rd));
        tracep->fullQData(oldp+26,(vlTOPp->CACHE__DOT__B0_DAT_RAM_rd_data),64);
        tracep->fullSData(oldp+28,(vlTOPp->CACHE__DOT__B0_DAT_RAM_rd_addr),9);
        tracep->fullBit(oldp+29,(vlTOPp->CACHE__DOT__B0_DAT_RAM_wr));
        tracep->fullQData(oldp+30,(vlTOPp->CACHE__DOT__B0_DAT_RAM_wr_data),64);
        tracep->fullSData(oldp+32,(vlTOPp->CACHE__DOT__B0_DAT_RAM_wr_addr),9);
        tracep->fullBit(oldp+33,(vlTOPp->CACHE__DOT__B0_TAG_RAM_rd));
        tracep->fullIData(oldp+34,(vlTOPp->CACHE__DOT__B0_TAG_RAM_rd_data),26);
        tracep->fullSData(oldp+35,(vlTOPp->CACHE__DOT__B0_TAG_RAM_rd_addr),9);
        tracep->fullBit(oldp+36,(vlTOPp->CACHE__DOT__B0_TAG_RAM_wr));
        tracep->fullIData(oldp+37,(vlTOPp->CACHE__DOT__B0_TAG_RAM_wr_data),26);
        tracep->fullSData(oldp+38,(vlTOPp->CACHE__DOT__B0_TAG_RAM_wr_addr),9);
        tracep->fullBit(oldp+39,(vlTOPp->CACHE__DOT__B1_DAT_RAM_rd));
        tracep->fullQData(oldp+40,(vlTOPp->CACHE__DOT__B1_DAT_RAM_rd_data),64);
        tracep->fullSData(oldp+42,(vlTOPp->CACHE__DOT__B1_DAT_RAM_rd_addr),9);
        tracep->fullBit(oldp+43,(vlTOPp->CACHE__DOT__B1_DAT_RAM_wr));
        tracep->fullQData(oldp+44,(vlTOPp->CACHE__DOT__B1_DAT_RAM_wr_data),64);
        tracep->fullSData(oldp+46,(vlTOPp->CACHE__DOT__B1_DAT_RAM_wr_addr),9);
        tracep->fullBit(oldp+47,(vlTOPp->CACHE__DOT__B1_TAG_RAM_rd));
        tracep->fullIData(oldp+48,(vlTOPp->CACHE__DOT__B1_TAG_RAM_rd_data),26);
        tracep->fullSData(oldp+49,(vlTOPp->CACHE__DOT__B1_TAG_RAM_rd_addr),9);
        tracep->fullBit(oldp+50,(vlTOPp->CACHE__DOT__B1_TAG_RAM_wr));
        tracep->fullIData(oldp+51,(vlTOPp->CACHE__DOT__B1_TAG_RAM_wr_data),26);
        tracep->fullSData(oldp+52,(vlTOPp->CACHE__DOT__B1_TAG_RAM_wr_addr),9);
        tracep->fullBit(oldp+53,(vlTOPp->clk));
        tracep->fullBit(oldp+54,(vlTOPp->res_n));
        tracep->fullBit(oldp+55,(vlTOPp->lock));
        tracep->fullBit(oldp+56,(vlTOPp->unlock));
        tracep->fullIData(oldp+57,(vlTOPp->key),32);
        tracep->fullQData(oldp+58,(vlTOPp->phys_addr_in),40);
        tracep->fullBit(oldp+60,(vlTOPp->phys_addr_in_vld));
        tracep->fullQData(oldp+61,(vlTOPp->data_from_mem),64);
        tracep->fullBit(oldp+63,(vlTOPp->data_from_mem_vld));
        tracep->fullQData(oldp+64,(vlTOPp->data_from_cpu),64);
        tracep->fullBit(oldp+66,(vlTOPp->data_from_cpu_vld));
        tracep->fullQData(oldp+67,(vlTOPp->data_to_cpu),64);
        tracep->fullBit(oldp+69,(vlTOPp->data_to_cpu_vld));
        tracep->fullQData(oldp+70,(vlTOPp->data_to_victim_buffer),64);
        tracep->fullBit(oldp+72,(vlTOPp->data_to_victim_buffer_vld));
        tracep->fullBit(oldp+73,(vlTOPp->miss));
        tracep->fullBit(oldp+74,(vlTOPp->locked));
        tracep->fullCData(oldp+75,(vlTOPp->CACHE__DOT__STATE),4);
        tracep->fullBit(oldp+76,((0xffffffffU == vlTOPp->key)));
        tracep->fullSData(oldp+77,((0x1ffU & (IData)(
                                                     (vlTOPp->phys_addr_in 
                                                      >> 6U)))),9);
        tracep->fullCData(oldp+78,((0x3fU & (IData)(vlTOPp->phys_addr_in))),6);
        tracep->fullIData(oldp+79,((0x1ffffffU & (IData)(
                                                         (vlTOPp->phys_addr_in 
                                                          >> 0xfU)))),25);
        tracep->fullIData(oldp+80,(0x100U),32);
        tracep->fullIData(oldp+81,(0x28U),32);
        tracep->fullIData(oldp+82,(9U),32);
        tracep->fullIData(oldp+83,(6U),32);
        tracep->fullIData(oldp+84,(0x20U),32);
        tracep->fullIData(oldp+85,(0xffffffffU),32);
        tracep->fullBit(oldp+86,(0U));
        tracep->fullBit(oldp+87,(1U));
        tracep->fullIData(oldp+88,(0x19U),32);
        tracep->fullIData(oldp+89,(0x40U),32);
        tracep->fullIData(oldp+90,(0x200U),32);
        tracep->fullQData(oldp+91,(0ULL),64);
        tracep->fullIData(oldp+93,(0U),25);
        tracep->fullIData(oldp+94,(0x1aU),32);
        tracep->fullIData(oldp+95,(0x200U),32);
        tracep->fullIData(oldp+96,(9U),32);
        tracep->fullSData(oldp+97,(0U),9);
        tracep->fullIData(oldp+98,(0U),26);
        tracep->fullIData(oldp+99,(0x3ffffffU),26);
        tracep->fullIData(oldp+100,(0x40U),32);
        tracep->fullQData(oldp+101,(0xffffffffffffffffULL),64);
    }
}
